c     FORTRAN77 code
c     File: tfore.for
c
c     This program is intended for nonlinear error correction models
c     It provides measures of forecasting power of TVECM models
c     
c     Created by Antoni Vidiella to analyze interest rates
c
c     Parameters of the model must be given
c     DVAR is not already prepared!
c     Prepared for file input obtained of tmlest.for or tlsest.for
c     input:  dat(.,.) is the data matrix 2 columns of data
ccccc Current setting
c
c     Number-variables = 2
c     max-ar-p = 29
c     max-obs  = 500
c     maximum number of regimes = 5
c
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      integer seed
      parameter(nmax=500,ipmax=3,ithmax=5)
      dimension dat(nmax,ipmax),x42(ipmax,1),var(ipmax)
      dimension predm(nmax,ipmax),d(ipmax,ipmax)
      dimension thr(ithmax),rnn(ipmax),pred(nmax,ipmax)
      dimension cep(ipmax),rlop(ipmax),ri(200)
      dimension cov(ipmax,ipmax,2),error(nmax,ipmax)
      dimension cov1(ipmax,ipmax),x39(nmax,ipmax),x40(2*ipmax,1)
      dimension nr(2),res(nmax,ipmax,2),d5(ipmax,2*ipmax,2)
      dimension d1(ipmax,ipmax),d2(ipmax,ipmax),d3(ipmax,ipmax)
      dimension pi(ipmax,ipmax),ai(ipmax,ipmax),d6(ipmax,ipmax*2)
c
      character nfile*30,nfile2*30,nfile1*30,nfile3*30
      external zeromat,addmat,multmat,zerovec,chlsk,gnorm
      external randu
c
      write(6,*) 'out?'
      call zeromat(error,nmax,nmax,ipmax)
      read(5,*) nfile3
      open(17,file=nfile3,status='unknown')
c
ccccc Introduction of data
c
      seed=123456789
      write(6,100)
      write(6,101)
      write(6,103)
      write(6,104)
      write(6,501)


 100  format(1x,'Please choose the forecasting method: ')
 101  format(1x,'1. Skeleton ')
 103  format(1x,'2. Monte Carlo ')
 104  format(1x,'3. Bootstrapping ')
 501  format(' ')
      read(5,*) ifor
      write(6,83)
c      read(5,*) inp
      inp=1
 83   format(1x,'Screen Input (0) or File Input(1)? :')
      if (inp.eq.1) then
         write(6,84)
         read(5,*) nfile1
 84      format(1x,'Name of Input file :')
         open(18,file=nfile1,status='unknown')
         read(18,*) kind
         nreg=2
         if (kind.eq.1.or.kind.eq.2) then
            nreg=1
            thr(2)=9.d+10
         endif
         read(18,*) int
         npam=2+int
         if (kind.eq.1) npam=4+int
         do 85 i=1,nreg
            do 86 j=1,2
 86            read(18,*) (d1(j,k),k=1,npam)
            if (kinf.ne.1) then            
c estimation is made using non-stationary VAR speceficiation
               cep(1)=1.0
               if (kind.eq.3) then
                  cep(2)=1.0
                  cep(3)=0.0
                  ikl=1.0
               else
                  ikl=-1.0
                  read(18,*) (cep(k),k=2,3)
               endif
               read(18,*) (rlop(k),k=1,2)
               ib=0
               if(cep(3).gt.0.0) ib=1
               cep(2)=-cep(2)
               do 87 k1=1,2
                  do 87 k2=1,2+ib
 87                  pi(k1,k2)=ikl*rlop(k1)*cep(k2)
               npamh=2+ib
               write(6,*) ' '
c  first order regressors
               do 95 j=1,2
                  do 95 k=1+int,2+int
 95                 d(j,k-int)=d1(j,k)
               call zeromat(ai,ipmax,ipmax,ipmax)
               do 96 iv=1,2
 96               ai(iv,iv)=1.0
               call addmat(ai,pi,d2,ipmax,2,2,1)
               call addmat(d2,d,d3,ipmax,2,2,1)
c d3 are VAR(1) coefficients matrix
               do 97 j=1,2
                  if (int.eq.1) d5(j,1,i)=d1(j,1)
                  do 97 k=1,2 
                     d5(j,int+k,i)=d3(j,k)
 97                  d5(j,2+int+k,i)=-d(j,k)
            endif
            do 88 k1=1,2
 88            read(18,*) (cov(k1,k2,i),k2=1,2)
 85      continue 
         id=1
c         read (18,93) nfile
         nfile='irat.dat'
         nob=0
         open(9,file=nfile,status='unknown')
c         read(18,*) nob
         nob=499
         do 89 i=1,nob
 89         read(9,*) (dat(i,j),j=1,2)
         close(9)
         if (kind.eq.3.or.kind.eq.4) then 
            read(18,*) b1
            read(18,*) thr(2)
         endif
         ip=2
         goto 108
      endif
      write(6,1)
      write(6,2)
      write(6,3)
      write(6,4)
      write(6,5)
      write(6,501)
 1    format(1x,'Please choose the model to forecast: ')
 2    format(1x,'1. DVAR ')
 3    format(1x,'2. VECM ')
 4    format(1x,'3. MTAR ')
 5    format(1x,'4. TVECM ')
      read(5,*) kind
      nreg=2
      if (kind.eq.1.or.kind.eq.2) nreg=1
      write(6,6)
      int=0
      read(5,*) int
 6    format(1x,'Does the model have intercept? (yes=1,no=0): ')
      npam=2+int
      if (kind.eq.1.or.kind.eq.3) npam=4+int
      do 11 i=1,nreg
         if (nreg.gt.1) write(6,8) i
         do 10 j=1,2
            write (6,501)
            write (6,9) j,npam
 10         read(5,*) (d1(j,k),k=1,npam)
c estimation is made using non-stationary VAR speceficiation
         if (kind.eq.2.or.kind.eq.4) then
            write(6,501)
            write(6,14)
            cep(1)=1.0
            read(5,*) (cep(k),k=2,3)
            write(6,501)
            write(6,15)
            read(5,*) (rlop(k),k=1,2)
            ib=0
            if(cep(3).gt.0.0) ib=1
            cep(2)=-cep(2)
            do 18 k1=1,2
               do 18 k2=1,2+ib
 18               pi(k1,k2)=-rlop(k1)*cep(k2)
            npamh=2+ib
c  first order regressors
            do 94 j=1,2
               do 94 k=1+int,2+int
 94               d(j,k-int)=d1(j,k)
               call zeromat(ai,ipmax,ipmax,ipmax)
               do 98 iv=1,2
 98               ai(iv,iv)=1.0
               call addmat(ai,pi,d2,ipmax,2,2,1)
               call addmat(d2,d,d3,ipmax,2,2,1)
c d3 are VAR(1) coefficients matrix
               do 99 j=1,2
                  if (int.eq.1) d5(j,1,i)=d1(j,1)
                  do 99 k=1,2 
                     d5(j,int+k,i)=d3(j,k)
 99                  d5(j,2+int+k,i)=-d(j,k)
            endif
            write(6,501)
            write(6,16)
            do 20 k1=1,2
 20            read(5,*) (cov(k1,k2,i),k2=1,2)
 11   continue 
 8    format(1x,'Parameters of regime:',i3,' 1=lower, 2 upper')
 9    format(1x,'Input parameters of equation:',i3,' ; ',i3,'
     1parameters are required')
 14   format(1x,'Input parameters of CE (if no intercept 2nd=0.0)')
 15   format(1x,'Input parameters of loading vector')
 16   format(1x,'Input parameters of covariance matrix')
c
      id=1
      write(6,19)
 19   format(1x,'Data File Name : ')
      read (5,93) nfile
 93   format(a30)
      nob=0
      open(9,file=nfile,status='unknown')
      read(9,*) nob
      do 17 i=1,nob
 17      read(9,*) (dat(i,j),j=1,2)
      close(9)
c--------- input thresholds
      if (kind.eq.3.or.kind.eq.4) then
             write(6,50)
             read(5,*) b1
      endif
 50   format(1x,'Enter parameter of cointegration (1, x): ')
      ip=2
      write(6,40) 
      read(5,*) thr(2)      
      thr(1) = -9.9d+10
      thr(3) = 9.9d+10
 40   format(1x,'input threshold: ')
 108  continue
      if (ifor.eq.3) then
         write(6,105)
         read(5,93) nfile2
         open(10,file=nfile2,status='unknown')
         do 110 i=1,nreg
            read(10,*) nr(i)
            do 110 j=1,nr(i)
 110           read(10,*) (res(j,k,i),k=1,2)
         close(10)
      endif
 105  format(1x,' Residuals File Name : ')
 107  continue
      write (6,106)
 106  format(1x,'Input forecasting period 1st & nend : ')
      read(5,*) ist,nend
      if (nend.gt.nob) then
         write(6,*) 'Out of sample ! input another forescating date'
         goto 107
      endif      
c     inici del proces de forescasting
c     istep  # de step ahead of forecasting
c el problema es que no puc anar acumulant prediccions per al no-lineal,
c s'han d'anar calculant separadament fins a cada h-step
      ist=ist-1
      istep=nend-ist
      do 43 i=1,istep
         do 43 j=1,2
 43         x39(i,j)=dat(ist+i,j)
      if(ifor.eq.1) then 
         isim=1  
      else if(ifor.eq.2.or.ifor.eq.3) then
         write(6,501)
         write(6,191)
         read(5,*) isim
      endif
      if(ifor.eq.3.or.ifor.eq.1) goto 992
      do 190 i=1,nreg
         do 195 j=1,2
            do 195 k=1,2
 195           cov1(j,k)=cov(j,k,i)
                  call chlsk(ipmax,2,cov1,nrang,det,kode)
            do 181 j=1,2
               do 181 k=1,2
 181              cov(j,k,i)=cov1(j,k)
 190  continue
 992  continue
 191  format(1x,'Num. of simulations for each forecast? max=1000')
c a cov hi ha la descomposicio de cholesky de la matriu de covariancies
c ara haig de generar dos nombres aleatoris normals i independents.
c a ij hi ha el nombre de periodes a simular
      if(isim.gt.1000) isim=1000
      do 198 iq=1,isim
         do 192 ik=1,istep           
            call zerovec(var,ipmax,ipmax)    
               if (int.eq.1) x40(1,1)=1.0
               do 196 i=1,2
                  if (ik.gt.1) dat(ist+ik-1,j)=var(j)
                  x40(int+i,1)=dat(ist+ik-1,i)
 196              x40(2+int+i,1)=dat(ist+ik-2,i)
               ia=1
               if (kind.eq.3.or.kind.eq.4) then
                  err=0.0
                  err=dat(ist+ik-1,1)-b1*dat(ist+ik-1,2)
                  if(err.ge.thr(2)) ia=2
               endif
               if(ifor.eq.2) then
                  call zerovec(RI,100,100)
                  call gnorm(ri,100,seed)
c agafo com a nombres aleatoris el 50 i el 100
c i calculo les innovacions correlacionades emprant el resultat de cholesky            
                  rnn(1)=ri(50)*cov(1,1,ia)
                  rnn(2)=ri(50)*cov(2,1,ia)+ri(100)*cov(2,2,ia)
               else if(ifor.eq.3) then
 997              continue
                  CALL ZEROVEC(RI,100,100)            
                  ipos=idint(randu(seed)*nr(ia))
                  if (ipos.eq.0) goto 997
                  do 999 i=1,2
 999                 rnn(i)=res(ipos,i,ia)
               else if(ifor.eq.1) then
                  call zerovec(rnn,ipmax,ipmax)
               endif
               do 173 i=1,2
                  do 173 j=1,2*npam-int
 173                 d6(i,j)=d5(i,j,ia)
               call multmat(d6,x40,x42,ipmax,ipmax*2,2,2*npam-int,1)
               do 171 j=1,2
 171              var(j)=x42(j,1)+rnn(j)
               do 199 j=1,2
 199              pred(ik,j)=pred(ik,j)+var(j)
               call zeromat(x40,2*ipmax,2*ipmax,1)
               call zeromat(x42,ipmax,ipmax,1)
               call zeromat(d6,ipmax,2,ipmax*2)
               call zerovec(rnn,ipmax,ipmax)
 192        continue
 198     continue
         do 205 i=1,istep
            do 205 j=1,2
 205           predm(i,j)=pred(i,j)/real(isim)
c            write(17,501)
c            write(17,220) nend
c            write(17,300)
c            write(17,302)
c            write(17,300)
c            do 206 j=1,istep
c 206           write(17,*) (predm(j,i),i=1,2), j
c            write(17,*) 'actual',(x39(i,1),i=1,2)
            do 230 i=1,istep
               do 230 j=1,2
 230              error(i,j)=(x39(i,j)-predm(i,j))**2
       
c we have to compute the square error of forecasting
 220    format(2x,'prediction of the value : ',i3)
 200    continue
c      write(17,300)
c      write(17,301)
c      write(17,300)
      do 240 i=1,60
 240     write(17,*) error(i,1)
      do 241 i=1,60
 241     write(17,*) error(i,2)
 300  format(' ')
 301  format('Squared Forecasting errors :')
 302  format('Forecasting Values :')
      close(17)
      end       


      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      DO 99 J=1,L3
         DO 98 K=1,L2
            IF (BMAT(K,J).EQ.0.0) GOTO 98
            DO 97 I=1,L1
               CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END
     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
         DO 99 I=1,L1
            AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END


      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION VEC(ID1MAX)


      DO 98 I=1,L1     
                VEC(I)=0.0
  98  CONTINUE
      RETURN
        END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
C
      DO 98 J=1,L2
         DO 99 I=1,L1
            BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END


      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
            VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END


      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      CALL ZEROMAT(CMAT,ID1MAX,L1,L3)
      DO 2 J=1,L1
         DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END



C*********************************CHLSK******************************
      SUBROUTINE CHLSK (NDIM,N,W,NRANG,DET,KODE)
C********************************************************************
C  DESCOMPOSICION DE CHOLESKY DE LA MATRIZ SIMETRICA SEMIDEFINIDA 
C  POSITIVA W(N,N). NDIM=DIMENSION RESERVADA PARA W(NDIM,NDIM)
C
C  SALIDAS:
C    W(,) MATRIZ TRIANGULAR INFERIOR TAL QUE W*WPRIM=MATRIZ INICIAL
C    NRANG RANGO DE W (SI NRANG.LT.N SE PONE A 0 LAS FILAS EN CUESTION
C    DET DETERMINANTE DE W
C    KODE=1 SI W NO FUESE SEMIDEF. POSITIVA, SINO KODE=0
C*********************************************************************
        implicit real*8 (a-h,o-z)
        DIMENSION W(NDIM,n)
        DATA EPS / 1.0d-4 /
        KODE=0
        NRANG=N
        DET=1.0
          DO 70 I=1,N 
          DO 40 J=1,I
        V=W(I,J)
          DO 10 L=1,J
          IF (L.EQ.J)            GO TO 20
10      V=V-W(I,L)*W(J,L)
20        CONTINUE
          IF (I .EQ. J)          GO TO 50
        W(J,I)=0.0
          IF (W(J,L).EQ.0.0)     GO TO 30
        W(I,J)=V/W(J,L)
                                 GO TO 40
30      W(J,I)=0.0
40        CONTINUE
50      EPSIL=ABS(EPS*W(I,J))
          IF (ABS(V).LE.EPSIL)   GO TO 60
          IF (V.LT.0.0)          GO TO 80
        DET=DET*V
        W(I,J)=SQRT(V)
                                 GO TO 70
60      W(I,J)=0.0
        DET=0.0
        NRANG=NRANG-1
70      CONTINUE
         RETURN
80      KODE=1
         RETURN
         END


       subroutine gnorm(r,nr,rs)
       implicit real*8 (a-h,o-z)
       integer nr,rs
       dimension r(*)
       do  1 i=1,nr
99        continue         
          v=randu(rs)*2.-1.
          u=randu(rs)*2.-1.
          w=v*v+u*u
          if(w.gt.1)goto 99
          c=sqrt(-2.*dlog(w)/w)
          R(i)=c*v
          r(i+1)=c*u
1      continue
       return
       end                      
                   
C**************************************************************************  
C  
      REAL*8 FUNCTION RANDU(IX)  
C  
C UNIFORM RANDOM NUMBER GENERATOR.  
C REF: SCHRAGE, L. 1979 'A MORE PORTABLE FORTRAN RANDOM NUMBER GENERATOR'  
C      A. C. M. TRANSACTIONS ON MATHEMATICAL SOFTWARE V5 132-138.  
C
      implicit real*8 (a-h,o-z)   
      INTEGER A,P,IX,B15,B16,XHI,XALO,LEFTLO,FHI,K  
      DATA A/16807/,B15/32768/,B16/65536/,P/2147483647/  
      XHI=IX/B16  
      XALO=(IX-XHI*B16)*A  
      LEFTLO=XALO/B16  
      FHI=XHI*A+LEFTLO  
      K=FHI/B15  
      IX=(((XALO-LEFTLO*B16)-P)+(FHI-K*B15)*B16)+K  
      IF (IX.LT.0) IX=IX+P  
      RANDU=real(IX)*4.656612875d-10  
      RETURN  
      END  
C
