c     FORTRAN77 code
c     File: tmlest.for
c
c     This program is intended for nonlinear threshold
c     error correction models
c     It estimates a bivariate nonlinear error correction model
c
c     Created by Antoni Vidiella to analyze interest rates
c
c     The program estimates a threshold-regression model: threshold
c     variable and its threshold must be given. MLE is performed in each
c     regime
c
ccccc Current setting
c
c     Number-variables = 2
c     max-ar-p = 29
c     max-obs  = 500
c     maximum number of regimes = 5
c
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      parameter(nmax=500,mk=3,ipmax=3,kmax=20,ithmax=3)
      dimension dat(nmax,ipmax),er(ipmax,ipmax)
      dimension dat2(nmax,ipmax),dat3(nmax,ipmax),dat4(nmax,ipmax)
      dimension npts(mk),y1(ipmax,nmax),x1(ipmax,nmax),x2(nmax,ipmax)
      dimension x3(ipmax,ipmax),x4(ipmax,ipmax),x5(ipmax,nmax)
      dimension x6(nmax,nmax),x9(nmax,1),x13(ipmax,1),x17(1,nmax)
      dimension x7(nmax,nmax),x8(ipmax,nmax),coef2(ipmax,1)
      dimension x10(nmax,1),x11(ipmax,1),x12(ipmax,nmax)
      dimension x14(1,ipmax),x15(1,1),h(ipmax,1),x16(nmax,ipmax)
      dimension x18(ipmax,nmax),x19(ipmax,nmax),d(ipmax,ipmax)
      dimension x22(1,nmax),x23(1,1),x24(kmax,kmax),elp1(ipmax,ipmax)      
      dimension x26(kmax,kmax),x27(kmax,kmax),x28(kmax,kmax)
      dimension x29(kmax,kmax),x30(ipmax,nmax),x31(ipmax,nmax)
      dimension x32(ipmax,nmax),x33(nmax,ipmax),x34(ipmax,kmax)
      dimension x35(2*kmax,2*kmax),thr(ithmax),x20(ipmax,1)
      dimension xm(nmax,nmax),elp(kmax,kmax),x25(kmax,kmax)
      dimension coef3(ipmax,1),h2(1,ipmax),c4(ipmax,1)
      dimension pi2(ipmax,ipmax),d7(ipmax,ipmax),pi3(ipmax,ipmax)
      dimension h3(1,ipmax),h4(1,1),h5(1,1),d8(ipmax,1)
      dimension pi(ipmax,ipmax),erpi(ipmax,ipmax),coef4(1,ipmax)
      dimension h6(1,ipmax),h8(ipmax,1),c5(ipmax,1),h10(ipmax,1)
      dimension h11(ipmax,1),h9(ipmax,1),h13(1,ipmax)
      dimension x51(nmax,ipmax),y51(nmax,2),xlag(nmax,2)
      dimension x52(ipmax,nmax),x53(ipmax,ipmax),x54(ipmax,ipmax)
      dimension x55(nmax,ipmax),x56(ipmax,2),x57(nmax,2),x58(nmax,2)
      dimension x59(ipmax,2),x60(nmax,2),x61(nmax,2),x62(2,nmax)
      dimension x63(2,2),x64(2,nmax),x65(2,2),x66(2,2),x67(2,2)
      dimension x68(2,2),x69(2,2),x70(2,2),x71(2,2),x72(2,2)
      dimension fv1(2),iv1(2),z1(2,2),elp3(2,2)
      dimension wr(2),wi(2),beta2(2)


c
      character nfile*30
      external eqmat,zeromat,addmat,matinv,trnmat,multmat,detmtx
c
      open (10,file='tvest.res',status='unknown')
      open (11,file='resid.res',status='unknown')
      open (12,file='stdrs.res',status='unknown')
c
ccccc Introduction of data
c
      write(6,1)
      write(10,47)
      write(10,501)
      write(10,1)
 47   format(1x,'ESTIMATION OUTPUT OF A TVECM')
      write(10,501)
 1    format(1x,'N.obs, delay, nregime :')
      read(5,*) nob, id, nreg
      ict=1
      write(10,11) nob, id, nreg, ict
 11   format(1x,i5,3x,i5,3x,i5,3x,i5)          
      if (nob.le.0) stop
      if (nob.gt.nmax) nob=nmax
      if (id.lt.0) id=0
      write(10,501)
      write(6,2)
      write(10,2)
 2    format(1x,'Data File Name : ')
      read (5,3) nfile
      write(10,3) ' ',nfile
      write(10,501)
 3    format(a30)
      open(9,file=nfile,status='old')
      open(17,file='tvres.out',status='unknown')
      open(18,file='tvest.out',status='unknown')
      kind=4
      if (nreg.eq.1) kind=2
      write(18,*) kind
      write(18,*) ict
      nob1=nob
      call zeromat(dat,nmax,nmax,ipmax)
      do 10 i=1,nob
 10       read(9,*) (dat(i,j),j=1,2)
      close(9)
      write (6,6)
      ist=2
 6    format(1x,'input data span (1= yes) : ')
      read(5,*) ii
      if (ii.eq.1) then         
	write(6,12)
	read(5,*) ist,nend
	write(10,7) ist,nend
	write(10,501)
	if(nend.gt.nob) nend=nob
	if(ist.lt.1) ist = 1
	nob = nend-ist+1
	if(ist.eq.1)go to 30
	do 20 it=1, nob
	   do 20 i=1, 2
 20           dat(it,i) = dat(it-1+ist,i)
      endif
 7    format(1x,'Range of data: ',i4,'-',i4)
 12   format(1x,'data span (nst, nend): ')
 30   continue
      if(nreg.gt.1)then 
c--------- input thresholds
	 write(6,40) nreg-1
	 read(5,*) (thr(i),i = 2, nreg)
	 do 43 i=1,nreg-1
 43        write(10,41) thr(1+i) 
	 write(6,50)
	 read(5,*) b1
	 write(10,501)
	 write(10,*) 'Slope of threshold equation : ',b1
	 do 44 it=1, nob
 44        dat(it,3)=dat(it,1)-b1*dat(it,2)
      endif
      thr(1) = -9.9d+10
      i = nreg+1
      thr(i) = 9.9d+10
 40   format(1x,'input', i5,' thresholds: ')
 41   format(1x,'Threshold : ',f10.5)
      nob=nob-1
      do 46 i=1,nob
	 do 46 j=1,2
 46        dat2(i,j)= dat(i+1,j)-dat(i,j)              
 50   format(1x,'Enter beta parameter in threshold equation :')
      ip=2
      if (ist.lt.ip) ist=ip
c------------------- icnt: number of data points in this regime.
      do 90 ia=1,nreg
	 icnt = 0
	 ifail= 0
	 ierr = 0
	 do 100 it = ist, nob
	    chk = dat(it,3)  
	    if(chk.lt.thr(ia)) go to 100
	    if(chk.gt.thr(ia+1)) go to 100
c------------- the observation is in the ia-th regime
	    icnt = icnt+1
	    do 52 ij=1,2
	       dat3(icnt,ij)=dat2(it,ij)
 52            dat4(icnt,ij)=dat(it,ij)
	       x51(icnt,1)=1.0
	       do 335 k=1,2
 335           x51(icnt,1+k)=dat(it,k)-dat(it-1,k)
	       do 336 j=1,2
		   y51(icnt,j)=dat(it+1,j)-dat(it,j)
 336           xlag(icnt,j)=dat(it,j)
 100     continue
	 write(10,501)
	 write(10,500)
	 write(10,501)
	 npts(ia) = icnt
	 if (icnt.le.20) then
	    print*,'insufficient data points in the', ia,'-th regime'
	    stop
	 endif
	 ior=(ip-1)*2+ict
	 call trnmat(x51,x52,nmax,ipmax,icnt,ior)
	 call multmat(x52,x51,x53,ipmax,nmax,ior,icnt,ior)
	 call matinv(x53,x54,elp1,ipmax,ior,ifail)      
	 call multmat(x51,x54,x55,nmax,ipmax,icnt,ior,ior)
	 call multmat(x52,y51,x56,ipmax,nmax,ior,icnt,2)
	 call multmat(x55,x56,x57,nmax,ipmax,icnt,ior,2)
	 call addmat(y51,x57,x58,nmax,icnt,2,-1)
	 call multmat(x52,xlag,x59,ipmax,nmax,ior,icnt,2)
	 call multmat(x55,x59,x60,nmax,ipmax,icnt,ior,2)
	 call addmat(xlag,x60,x61,nmax,icnt,2,-1)
	 call trnmat(x58,x62,nmax,2,icnt,2)
	 call multmat(x62,x58,x63,2,nmax,2,icnt,2)
	 call trnmat(x61,x64,nmax,2,icnt,2)
	 call multmat(x64,x61,x65,2,nmax,2,icnt,2)
	 call matinv(x65,x66,elp3,2,2,ifail)
	 call multmat(x64,x58,x67,2,nmax,2,icnt,2)
	 call matinv(x63,x68,elp3,2,2,ifail)
	 call trnmat(x67,x69,2,2,2,2)
	 call multmat(x68,x69,x70,2,2,2,2,2)
	 call multmat(x67,x70,x71,2,2,2,2,2)
	 call multmat(x66,x71,x72,2,2,2,2,2) 
	 call rg(2,2,x72,wr,wi,z1,iv1,fv1,ierr)
	 ind=1
	 if(wr(1).lt.wr(2)) ind=2
	 beta=-z1(2,ind)/z1(1,ind)
	 beta2(1)=1.0
	 beta2(2)=-beta
	 call like(x51,xlag,beta2,y51,nmax,icnt,alike)
	 beta2(2)=-(beta+1.d-3)
	 call like(x51,xlag,beta2,y51,nmax,icnt,alike1)
	 beta2(2)=-(beta-1.d-3)
	 call like(x51,xlag,beta2,y51,nmax,icnt,alike2)
	 hp=(alike1+alike2-2.0*alike)/(1.d-3**2)
	 seb=1.0/dsqrt(hp)
	 call eqmat(x52,x1,ipmax,ipmax,3,icnt)
	 call trnmat(y51,y1,nmax,ipmax,icnt,2)
	 call zeromat(xm,nmax,icnt,icnt)
	 do 220 i=1,icnt
 220        xm(i,i)=1.0
	 call trnmat(x1,x2,ipmax,nmax,ior,icnt)
	 call multmat(x1,x2,x3,ipmax,nmax,ior,icnt,ior)
	 call matinv(x3,x4,elp1,ipmax,ior,ifail)      
	 call multmat(x4,x1,x5,ipmax,ipmax,ior,ior,icnt)
	 call multmat(x2,x5,x6,nmax,ipmax,icnt,ior,icnt)
	 call addmat(xm,x6,x7,nmax,icnt,icnt,-1)
c   x7 es la matriu m, ara es el moment de calcular Y-p, x8
	 call trnmat(dat4,x8,nmax,ipmax,icnt,2)
c   ara calculem el numerador
	 coef2(1,1)=1.0
	 coef2(2,1)=-beta
	 call multmat(dat4,coef2,x9,nmax,ipmax,icnt,2,1)
	 call multmat(x7,x9,x10,nmax,nmax,icnt,icnt,1)
      call multmat(y1,x10,x11,ipmax,nmax,2,icnt,1)
      call trnmat(dat4,x12,nmax,ipmax,icnt,2)
      call multmat(x12,x10,x13,ipmax,nmax,2,icnt,1)
      call trnmat(coef2,x14,ipmax,1,2,1)
      call multmat(x14,x13,x15,1,ipmax,1,2,1)
      do 230 i=1,2
 230     h(i,1)=-x11(i,1)/x15(1,1)
      call multmat(x2,x4,x16,nmax,ipmax,icnt,ior,ior)
      call multmat(x14,x12,x17,1,ipmax,1,2,icnt)
      call multmat(h,x17,x18,ipmax,1,2,1,icnt)
      call addmat(y1,x18,x19,ipmax,2,icnt,1)
      call multmat(x19,x16,d,ipmax,nmax,2,icnt,ior)
      do 231 iz=1,2
 231     write(18,*) (d(iz,iw),iw=1,ior)
      cep=0.0
      write(18,*) beta,cep
      write(18,*) (h(i,1),i=1,2)
      call trnmat(coef2,coef4,ipmax,1,2,1)
c  estimation of drift parameteres, coef3 ortogonal
      if (ict.eq.1) then
	 coef3(1,1)=-coef2(2,1)
	 coef3(2,1)=1.0
	 h2(1,1)=-h(2,1)
	 h2(1,2)=h(1,1)
c  computation of pi function
	 call zeromat(pi2,ipmax,ipmax,ipmax)
	 do 232 i=1,2
	    c4(i,1)=d(i,1)
	    pi2(i,i)=1.0
	    do 232 j=1,2
 232           d7(i,j)=d(i,1+j)
	 call addmat(pi2,d7,pi3,ipmax,2,2,-1)
	 call multmat(h2,pi3,h3,1,ipmax,1,2,2)
	 call multmat(h3,coef3,h4,1,ipmax,1,2,1)
	 h4(1,1)=1.0/h4(1,1)
	 call multmat(h2,c4,h5,1,ipmax,1,2,1)
	 h4(1,1)=h4(1,1)*h5(1,1)
	 h5(1,1)=0.0
	 do 233 i=1,2
 233        d8(i,1)=coef3(i,1)*h4(1,1)
	 write(10,501)
	 do 308 i=1,2
 308        write(10,516) i,d8(i,1)
c
c
	 call trnmat(h,h13,ipmax,1,2,1)
	 call multmat(h13,h,h5,1,ipmax,1,2,1)
	 h5(1,1)=1.0/h5(1,1)
c         do 241 i=1,2
c 241        h6(1,i)=h5(1,1)*coef4(1,i)
	 call multmat(h5,h13,h6,1,1,1,1,2)
c
	 h5(1,1)=0.0
	 call multmat(pi3,d8,h8,ipmax,ipmax,2,2,1)
	 call addmat(c4,h8,c5,ipmax,2,1,-1)
c         do 242 i=1,2
c 242        c5(i,1)=c4(i,1)-h8(i,1)
	 call multmat(h6,c5,h5,1,ipmax,1,2,1)
	 write(10,501)
	 write(10,517) h5(1,1)
c  checking correctness
	 call multmat(h,h5,h9,ipmax,1,2,1,1)
	 call multmat(pi3,d8,h10,ipmax,ipmax,2,2,1)
	 call addmat(h9,h10,h11,ipmax,2,1,1)
ccccccc
	 call zeromat(coef3,ipmax,ipmax,1)
	 call zeromat(h2,1,1,ipmax)
	 call zeromat(c4,ipmax,ipmax,1)
	 call zeromat(d7,ipmax,ipmax,ipmax)
	 call zeromat(h3,1,1,ipmax)
	 call zeromat(h4,1,1,1)
	 call zeromat(h5,1,1,1)
	 call zeromat(d8,ipmax,ipmax,1)
	 call zeromat(h6,1,1,ipmax)
	 call zeromat(h8,ipmax,ipmax,1)
	 call zeromat(h9,ipmax,ipmax,1)
	 call zeromat(h10,ipmax,ipmax,1)
	 call zeromat(h11,ipmax,ipmax,1)
	 call zeromat(h13,1,1,ipmax)
	 call zeromat(c5,ipmax,ipmax,1)
      endif
      call multmat(x1,x9,x20,ipmax,nmax,ior,icnt,1)
      call trnmat(x9,x22,nmax,1,icnt,1)
      call multmat(x22,x9,x23,1,nmax,1,icnt,1)
      call eqmat(x3,x24,ipmax,kmax,ior,ior)
      do 239 i=1,ior
	 do 239 j=1,ior
 239        x24(i,j)=x24(i,j)/real(icnt)
      do 240 i=1,ior
	 x24(i,ior+1)=x20(i,1)/real(icnt)
 240      x24(ior+1,i)=x20(i,1)/real(icnt)
       x24(ior+1,ior+1)=x23(1,1)/real(icnt)
c       ja esta calculada la matriu omega
       call matinv(x24,x25,elp,kmax,ior+1,ifail)
       call zeromat(x26,kmax,ior+2,ior+2)
       do 250 i=1,ior
 250      x26(i,i)=1.0
       do 255 i=1,2    
 255      x26(ior+i,ior+1)=coef2(i,1)
       call multmat(x26,x25,x27,kmax,kmax,ior+2,ior+1,ior+1)
       call trnmat(x26,x28,kmax,kmax,ior+2,ior+1)
       call multmat(x27,x28,x29,kmax,kmax,ior+2,ior+1,ior+2)
c  a x29 hi ha la matriu omega per les altres dos ior+2*ior+2
       call multmat(d,x1,x30,ipmax,ipmax,2,ior,icnt)
       call addmat(x30,x18,x31,ipmax,2,icnt,-1)
c  a x31 hi ha la prediccio, ara toca calcular l'error de prediccio
       call addmat(y1,x31,x32,ipmax,2,icnt,-1)
       write(17,*) icnt
       do 256 i=1,icnt
 256      write(17,*) x32(1,i),x32(2,i)
c      a x32 hi ha els vectors d'errors
       call trnmat(x32,x33,ipmax,nmax,2,icnt)
       call multmat(x32,x33,x34,ipmax,nmax,2,icnt,2)
       do 260 i=1,2
	  do 260 j=1,2
	     x34(i,j)=x34(i,j)/real(icnt-1)
 260      write(18,*) x34(i,j)
c  a x34 hi ha la estimacio de la matriu de var-cov dels errors
c  ara s'ha de fer el producte de Kronecker de les dues matrius
       do 270 i=1,ior+2
	  do 270 j=1,ior+2
	     do 270 k=1,2
		do 270 l=1,2
 270               x35((i-1)*2+k,(j-1)*2+l)=x29(i,j)*x34(k,l)
c      una vegada calculat el producte de Kronecker ja podem calcular
c      la significabilitat dels parametres
       kl=0
       do 400 i=1,ior
	  do 400 j=1,2
	     kl=kl+1
 400         er(j,i)=dsqrt(x35(kl,kl)/real(icnt))
       do 410 i=1,2
	  do 410 j=1,2
	     kl=kl+1
 410         erpi(j,i)=dsqrt(x35(kl,kl)/real(icnt))
c       a er(j,i) hi ha els errors estndards d'estimacio
       call multmat(h,coef4,pi,ipmax,1,2,1,2)
       write(10,501)
       write(10,515) icnt
       write(10,501)
       write(10,502)
       write(10,501)
       write(10,503)
       write(10,504) beta,seb,beta/seb
       write(10,501)
       write(10,505)
       write(10,501)
       do 302 i=1,2
	  write(10,506) i
	  write(10,501)
	  write(10,503)
	  do 304 j=1,ior
 304         write(10,504) d(i,j),er(i,j),d(i,j)/er(i,j)
	  write(10,501)
 302   continue
       write(10,507)
       write(10,501)
       write(10,503)
       do 300 i=1,2
 300      write(10,518) h(i,1)
       write(10,501)
       write(10,508)
       do 306 i=1,2
	  write(10,506) i
	  write(10,501)
	  write(10,503)
	  do 306 j=1,2
 306      write(10,504) pi(i,j),erpi(i,j),pi(i,j)/erpi(i,j)
       write(10,501)
       write(10,511)
       do 307 i=1,2
 307      write(10,512)(x34(i,j),j=1,2)
 512      format(1x,5f12.5)
       call zeromat(er,ipmax,ipmax,ipmax)
       call zeromat(dat3,nmax,nmax,ipmax)
       call zeromat(dat4,nmax,nmax,ipmax)
       call zeromat(y1,ipmax,ipmax,nmax)
       call zeromat(x1,ipmax,ipmax,nmax)
       call zeromat(x2,nmax,nmax,ipmax)
       call zeromat(x3,ipmax,ipmax,ipmax)
       call zeromat(x4,ipmax,ipmax,ipmax)
       call zeromat(x5,ipmax,ipmax,nmax)
       call zeromat(x6,nmax,nmax,nmax)
       call zeromat(x9,nmax,nmax,1)
       call zeromat(x13,ipmax,ipmax,1)
       call zeromat(x17,1,1,nmax)
       call zeromat(x7,nmax,nmax,nmax)
       call zeromat(x8,ipmax,ipmax,nmax)
       call zeromat(coef2,ipmax,ipmax,1)
       call zeromat(x10,nmax,nmax,1)
       call zeromat(x11,ipmax,ipmax,1)
       call zeromat(x12,ipmax,ipmax,nmax)
       call zeromat(x14,1,1,ipmax)
       call zeromat(x15,1,1,1)
       call zeromat(h,ipmax,ipmax,1)
       call zeromat(x16,nmax,nmax,ipmax)
       call zeromat(x18,ipmax,ipmax,nmax)
       call zeromat(x19,ipmax,ipmax,nmax)
       call zeromat(d,ipmax,ipmax,ipmax)
       call zeromat(x22,1,1,nmax)
       call zeromat(x23,1,1,1)
       call zeromat(x24,kmax,kmax,kmax)
       call zeromat(elp1,ipmax,ipmax,ipmax)
       call zeromat(x26,kmax,kmax,kmax)
       call zeromat(x27,kmax,kmax,kmax)
       call zeromat(x28,kmax,kmax,kmax)
       call zeromat(x29,kmax,kmax,kmax)
       call zeromat(x30,ipmax,ipmax,nmax)
       call zeromat(x31,ipmax,ipmax,nmax)
       call zeromat(x32,ipmax,ipmax,nmax)
       call zeromat(x33,nmax,nmax,ipmax)
       call zeromat(x34,ipmax,ipmax,kmax)
       call zeromat(x35,2*kmax,2*kmax,2*kmax)
       call zeromat(x20,ipmax,ipmax,1)
       call zeromat(xm,nmax,nmax,nmax)
       call zeromat(elp,kmax,kmax,kmax)
       call zeromat(x25,kmax,kmax,kmax)
       call zeromat(coef3,1,1,ipmax)
       call zeromat(pi,ipmax,ipmax,ipmax)
       call zeromat(erpi,ipmax,ipmax,ipmax)
       call zeromat(y51,nmax,nmax,2)
       call zeromat(x51,nmax,nmax,ipmax)
       call zeromat(x52,ipmax,ipmax,nmax)
       call zeromat(x53,ipmax,ipmax,ipmax)
       call zeromat(x54,ipmax,ipmax,ipmax)
       call zeromat(x55,nmax,nmax,ipmax)
       call zeromat(x56,ipmax,ipmax,2)
       call zeromat(x57,nmax,nmax,2)
       call zeromat(x58,nmax,nmax,2)
       call zeromat(xlag,nmax,nmax,2)
       call zeromat(x59,ipmax,ipmax,2)
       call zeromat(x60,nmax,nmax,2)
       call zeromat(x61,nmax,nmax,2)
       call zeromat(x62,2,2,nmax)
       call zeromat(x63,2,2,2)
       call zeromat(x64,2,2,nmax)
       call zeromat(x65,2,2,2)
       call zeromat(x66,2,2,2)
       call zeromat(x67,2,2,2)            
       call zeromat(x68,2,2,2)            
       call zeromat(x69,2,2,2)
       call zeromat(x70,2,2,2)            
       call zeromat(x71,2,2,2)
       call zeromat(x72,2,2,2)
       call zerovec(beta2,2,2)
       call zeromat(elp3,2,2,2)
       call zerovec(wr,2,2)
       call zeromat(z1,2,2,2)
 90    continue
       write(18,*) nfile
       write(18,*) nob1
       if (nreg.gt.1) then 
	  write(18,*) b1
	  write(18,*) thr(2)
       endif
 500   format(1x,'ESTIMATION RESULTS OF A TVECM 2-stages LS: ')
 501   format(' ')
 502   format(2x,'Cointegration Equation : ')
 503   format(2x,'Coefficient',5x,'Std.Errors',4x,'t-statistic')
 504   format(1x,f10.5,6x,f10.5,6x,f10.5)
 505   format(2x,'Error Correction : ')
 506   format(2x,'Component : ',i2)
 507   format(2x,'H vector :')
 508   format(2x,'HC matrix (estimation of PI matrix) : ')
 511   format(2x,'Residual Covariance Matrix: ')
 515   format(2x,'Number of points in this regime: ',i3)
 516   format(2x,'Long-run drift of variable ',i3,' : ',f10.5)
 517   format(2x,'Mean of cointegrating equation : ',f10.5)
 518   format(1x,f10.5)
       close(17)

      end       

      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      call zeromat(cmat,id1max,l1,l3)
      DO 99 J=1,L3
	 DO 98 K=1,L2
	    IF (BMAT(K,J).EQ.0.0) GOTO 98
	    DO 97 I=1,L1
	       CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END

      SUBROUTINE MATINV(AMAT,BMAT,ELP,ID1MAX,L1,IFAIL)
C************************************************************************
C     PORPOSE: MATRIX INVERSION
C     INPUT: AMAT, MATRIX DIMENSION L1,L1
C     OUTPUT: BMAT, MATRIX DIMENSION L1,L1
C             IFAIL, MONITORING VALUE
C************************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),ELP(ID1MAX,*)
      EXTERNAL EQMAT,ZEROMAT
C     
      CALL ZEROMAT(ELP,ID1MAX,L1,L1)
      CALL EQMAT(AMAT,ELP,ID1MAX,ID1MAX,L1,L1)
      DO 115 I=1,L1
	 BMAT(I,I)=1.0
  115 CONTINUE
      DO 99 J=1,L1
	 DO 98 I=J,L1
	    IF (ELP(I,J).NE.0.0) GOTO 11
   98    CONTINUE
	 IFAIL=1
	 RETURN
   11    CONTINUE
      DO 97 K=1,L1
C
	 PIVOT01= ELP(J,K)
	 ELP(J,K)= ELP(I,K)
	 ELP(I,K)= PIVOT01
C
	 PIV= BMAT(J,K)
	 BMAT(J,K)=BMAT(I,K)
	 BMAT(I,K)= PIV
   97 CONTINUE
C
      IF(ELP(J,J).NE.0.0) GOTO 22
C
      IFAIL=1
      RETURN
C
C
   22 CONTINUE
      PPP= 1.0/ELP(J,J)
      DO 96 K=1,L1
C
	 ELP(J,K)= ELP(J,K)*PPP
	 BMAT(J,K)= BMAT(J,K)*PPP
   96 CONTINUE
C
      DO 95 K=1,L1
C
	 IF(J.EQ.K) THEN
C
   33       CONTINUE
C
	 ELSE
	    PPP= ELP(K,J)
	    DO 94 L=1,L1
C
	       ELP(K,L)=ELP(K,L)-ELP(J,L)*PPP
	       BMAT(K,L)=BMAT(K,L)-BMAT(J,L)*PPP
   94       CONTINUE
C
	 END IF
   95 CONTINUE
   99 CONTINUE
C
      RETURN
      END

     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(ID1MAX)

      DO 98 I=1,L1     
		VEC(I)=0.0
  98  CONTINUE
      RETURN
	END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
C
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END

      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
	    VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END

      SUBROUTINE TRNMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C********************************************************************
C     PORPOSE: TRANSPOSE A MATRIX OF DIMENSION L1,L2
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: BMAT, TRANSPOSED MATRIX DIMENSION L2,L1
C********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
      external zeromat
C
      call zeromat(bmat,id2max,l2,l1)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(J,I)=AMAT(I,J)
   99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      CALL ZEROMAT(CMAT,ID1MAX,L1,L3)
      DO 2 J=1,L1
	 DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END


      subroutine rg(nm,n,a,wr,wi,z,iv1,fv1,ierr)
c
      integer n,nm,is1,is2,ierr
      double precision a(nm,n),wr(n),wi(n),z(nm,n),fv1(n)
      integer iv1(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real general matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real general matrix.
c
c     on output
c
c        wr  and  wi  contain the real and imaginary parts,
c        respectively, of the eigenvalues.  complex conjugate
c        pairs of eigenvalues appear consecutively with the
c        eigenvalue having the positive imaginary part first.
c
c        z  contains the real and imaginary parts of the eigenvectors
c        if matz is not zero.  if the j-th eigenvalue is real, the
c        j-th column of  z  contains its eigenvector.  if the j-th
c        eigenvalue is complex with positive imaginary part, the
c        j-th and (j+1)-th columns of  z  contain the real and
c        imaginary parts of its eigenvector.  the conjugate of this
c        vector is the eigenvector for the conjugate eigenvalue.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for hqr
c           and hqr2.  the normal completion code is zero.
c
c        iv1  and  fv1  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 call  balanc(nm,n,a,is1,is2,fv1)
      call  elmhes(nm,n,is1,is2,a,iv1)
      call  eltran(nm,n,is1,is2,a,iv1,z)
      call  hqr2(nm,n,is1,is2,a,wr,wi,z,ierr)
      if (ierr .ne. 0) go to 50
      call  balbak(nm,n,is1,is2,fv1,n,z)
   50 return
      end

      subroutine balanc(nm,n,a,low,igh,scale)
c
      integer i,j,k,l,m,n,jj,nm,igh,low,iexc
      double precision a(nm,n),scale(n)
      double precision c,f,g,r,s,b2,radix
      logical noconv
c
c     this subroutine is a translation of the algol procedure balance,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine balances a real matrix and isolates
c     eigenvalues whenever possible.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the input matrix to be balanced.
c
c     on output
c
c        a contains the balanced matrix.
c
c        low and igh are two integers such that a(i,j)
c          is equal to zero if
c           (1) i is greater than j and
c           (2) j=1,...,low-1 or i=igh+1,...,n.
c
c        scale contains information determining the
c           permutations and scaling factors used.
c
c     suppose that the principal submatrix in rows low through igh
c     has been balanced, that p(j) denotes the index interchanged
c     with j during the permutation step, and that the elements
c     of the diagonal matrix used are denoted by d(i,j).  then
c        scale(j) = p(j),    for j = 1,...,low-1
c                 = d(j,j),      j = low,...,igh
c                 = p(j)         j = igh+1,...,n.
c     the order in which the interchanges are made is n to igh+1,
c     then 1 to low-1.
c
c     note that 1 is returned for igh if igh is zero formally.
c
c     the algol procedure exc contained in balance appears in
c     balanc  in line.  (note that the algol roles of identifiers
c     k,l have been reversed.)
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      radix = 16.0d0
c
      b2 = radix * radix
      k = 1
      l = n
      go to 100
c     .......... in-line procedure for row and
c                column exchange ..........
   20 scale(m) = j
      if (j .eq. m) go to 50
c
      do 30 i = 1, l
	 f = a(i,j)
	 a(i,j) = a(i,m)
	 a(i,m) = f
   30 continue
c
      do 40 i = k, n
	 f = a(j,i)
	 a(j,i) = a(m,i)
	 a(m,i) = f
   40 continue
c
   50 go to (80,130), iexc
c     .......... search for rows isolating an eigenvalue
c                and push them down ..........
   80 if (l .eq. 1) go to 280
      l = l - 1
c     .......... for j=l step -1 until 1 do -- ..........
  100 do 120 jj = 1, l
	 j = l + 1 - jj
c
	 do 110 i = 1, l
	    if (i .eq. j) go to 110
	    if (a(j,i) .ne. 0.0d0) go to 120
  110    continue
c
	 m = l
	 iexc = 1
	 go to 20
  120 continue
c
      go to 140
c     .......... search for columns isolating an eigenvalue
c                and push them left ..........
  130 k = k + 1
c
  140 do 170 j = k, l
c
	 do 150 i = k, l
	    if (i .eq. j) go to 150
	    if (a(i,j) .ne. 0.0d0) go to 170
  150    continue
c
	 m = k
	 iexc = 2
	 go to 20
  170 continue
c     .......... now balance the submatrix in rows k to l ..........
      do 180 i = k, l
  180 scale(i) = 1.0d0
c     .......... iterative loop for norm reduction ..........
  190 noconv = .false.
c
      do 270 i = k, l
	 c = 0.0d0
	 r = 0.0d0
c
	 do 200 j = k, l
	    if (j .eq. i) go to 200
	    c = c + dabs(a(j,i))
	    r = r + dabs(a(i,j))
  200    continue
c     .......... guard against zero c or r due to underflow ..........
	 if (c .eq. 0.0d0 .or. r .eq. 0.0d0) go to 270
	 g = r / radix
	 f = 1.0d0
	 s = c + r
  210    if (c .ge. g) go to 220
	 f = f * radix
	 c = c * b2
	 go to 210
  220    g = r * radix
  230    if (c .lt. g) go to 240
	 f = f / radix
	 c = c / b2
	 go to 230
c     .......... now balance ..........
  240    if ((c + r) / f .ge. 0.95d0 * s) go to 270
	 g = 1.0d0 / f
	 scale(i) = scale(i) * f
	 noconv = .true.
c
	 do 250 j = k, n
  250    a(i,j) = a(i,j) * g
c
	 do 260 j = 1, l
  260    a(j,i) = a(j,i) * f
c
  270 continue
c
      if (noconv) go to 190
c
  280 low = k
      igh = l
      return
      end

      subroutine elmhes(nm,n,low,igh,a,int)
c
      integer i,j,m,n,la,nm,igh,kp1,low,mm1,mp1
      double precision a(nm,n)
      double precision x,y
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmhes,
c     num. math. 12, 349-368(1968) by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a real general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     low through igh to upper hessenberg form by
c     stabilized elementary similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the input matrix.
c
c     on output
c
c        a contains the hessenberg matrix.  the multipliers
c          which were used in the reduction are stored in the
c          remaining triangle under the hessenberg matrix.
c
c        int contains information on the rows and columns
c          interchanged in the reduction.
c          only elements low through igh are used.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
	 mm1 = m - 1
	 x = 0.0d0
	 i = m
c
	 do 100 j = m, igh
	    if (dabs(a(j,mm1)) .le. dabs(x)) go to 100
	    x = a(j,mm1)
	    i = j
  100    continue
c
	 int(m) = i
	 if (i .eq. m) go to 130
c     .......... interchange rows and columns of a ..........
	 do 110 j = mm1, n
	    y = a(i,j)
	    a(i,j) = a(m,j)
	    a(m,j) = y
  110    continue
c
	 do 120 j = 1, igh
	    y = a(j,i)
	    a(j,i) = a(j,m)
	    a(j,m) = y
  120    continue
c     .......... end interchange ..........
  130    if (x .eq. 0.0d0) go to 180
	 mp1 = m + 1
c
	 do 160 i = mp1, igh
	    y = a(i,mm1)
	    if (y .eq. 0.0d0) go to 160
	    y = y / x
	    a(i,mm1) = y
c
	    do 140 j = m, n
  140       a(i,j) = a(i,j) - y * a(m,j)
c
	    do 150 j = 1, igh
  150       a(j,m) = a(j,m) + y * a(j,i)
c
  160    continue
c
  180 continue
c
  200 return
      end

      subroutine eltran(nm,n,low,igh,a,int,z)
c
      integer i,j,n,kl,mm,mp,nm,igh,low,mp1
      double precision a(nm,igh),z(nm,n)
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmtrans,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine accumulates the stabilized elementary
c     similarity transformations used in the reduction of a
c     real general matrix to upper hessenberg form by  elmhes.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the multipliers which were used in the
c          reduction by  elmhes  in its lower triangle
c          below the subdiagonal.
c
c        int contains information on the rows and columns
c          interchanged in the reduction by  elmhes.
c          only elements low through igh are used.
c
c     on output
c
c        z contains the transformation matrix produced in the
c          reduction by  elmhes.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
c     .......... initialize z to identity matrix ..........
      do 80 j = 1, n
c
	 do 60 i = 1, n
   60    z(i,j) = 0.0d0
c
	 z(j,j) = 1.0d0
   80 continue
c
      kl = igh - low - 1
      if (kl .lt. 1) go to 200
c     .......... for mp=igh-1 step -1 until low+1 do -- ..........
      do 140 mm = 1, kl
	 mp = igh - mm
	 mp1 = mp + 1
c
	 do 100 i = mp1, igh
  100    z(i,mp) = a(i,mp-1)
c
	 i = int(mp)
	 if (i .eq. mp) go to 140
c
	 do 130 j = mp, igh
	    z(mp,j) = z(i,j)
	    z(i,j) = 0.0d0
  130    continue
c
	 z(i,mp) = 1.0d0
  140 continue
c
  200 return
      end

      subroutine hqr2(nm,n,low,igh,h,wr,wi,z,ierr)
c
      integer i,j,k,l,m,n,en,ii,jj,ll,mm,na,nm,nn,
     x        igh,itn,its,low,mp2,enm2,ierr
      double precision h(nm,n),wr(n),wi(n),z(nm,n)
      double precision p,q,r,s,t,w,x,y,ra,sa,vi,vr,zz,norm,tst1,tst2
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr2,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a real upper hessenberg matrix by the qr method.  the
c     eigenvectors of a real general matrix can also be found
c     if  elmhes  and  eltran  or  orthes  and  ortran  have
c     been used to reduce this general matrix to hessenberg form
c     and to accumulate the similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        h contains the upper hessenberg matrix.
c
c        z contains the transformation matrix produced by  eltran
c          after the reduction by  elmhes, or by  ortran  after the
c          reduction by  orthes, if performed.  if the eigenvectors
c          of the hessenberg matrix are desired, z must contain the
c          identity matrix.
c
c     on output
c
c        h has been destroyed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  the eigenvalues
c          are unordered except that complex conjugate pairs
c          of values appear consecutively with the eigenvalue
c          having the positive imaginary part first.  if an
c          error exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        z contains the real and imaginary parts of the eigenvectors.
c          if the i-th eigenvalue is real, the i-th column of z
c          contains its eigenvector.  if the i-th eigenvalue is complex
c          with positive imaginary part, the i-th and (i+1)-th
c          columns of z contain the real and imaginary parts of its
c          eigenvector.  the eigenvectors are unnormalized.  if an
c          error exit is made, none of the eigenvectors has been found.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      norm = 0.0d0
      k = 1
c     .......... store roots isolated by balanc
c                and compute matrix norm ..........
      do 50 i = 1, n
c
	 do 40 j = k, n
   40    norm = norm + dabs(h(i,j))
c
	 k = i
	 if (i .ge. low .and. i .le. igh) go to 50
	 wr(i) = h(i,i)
	 wi(i) = 0.0d0
   50 continue
c
      en = igh
      t = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalues ..........
   60 if (en .lt. low) go to 340
      its = 0
      na = en - 1
      enm2 = na - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
   70 do 80 ll = low, en
	 l = en + low - ll
	 if (l .eq. low) go to 100
	 s = dabs(h(l-1,l-1)) + dabs(h(l,l))
	 if (s .eq. 0.0d0) s = norm
	 tst1 = s
	 tst2 = tst1 + dabs(h(l,l-1))
	 if (tst2 .eq. tst1) go to 100
   80 continue
c     .......... form shift ..........
  100 x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (itn .eq. 0) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c     .......... form exceptional shift ..........
      t = t + x
c
      do 120 i = low, en
  120 h(i,i) = h(i,i) - x
c
      s = dabs(h(en,na)) + dabs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
  130 its = its + 1
      itn = itn - 1
c     .......... look for two consecutive small
c                sub-diagonal elements.
c                for m=en-2 step -1 until l do -- ..........
      do 140 mm = l, enm2
	 m = enm2 + l - mm
	 zz = h(m,m)
	 r = x - zz
	 s = y - zz
	 p = (r * s - w) / h(m+1,m) + h(m,m+1)
	 q = h(m+1,m+1) - zz - r - s
	 r = h(m+2,m+1)
	 s = dabs(p) + dabs(q) + dabs(r)
	 p = p / s
	 q = q / s
	 r = r / s
	 if (m .eq. l) go to 150
	 tst1 = dabs(p)*(dabs(h(m-1,m-1)) + dabs(zz) + dabs(h(m+1,m+1)))
	 tst2 = tst1 + dabs(h(m,m-1))*(dabs(q) + dabs(r))
	 if (tst2 .eq. tst1) go to 150
  140 continue
c
  150 mp2 = m + 2
c
      do 160 i = mp2, en
	 h(i,i-2) = 0.0d0
	 if (i .eq. mp2) go to 160
	 h(i,i-3) = 0.0d0
  160 continue
c     .......... double qr step involving rows l to en and
c                columns m to en ..........
      do 260 k = m, na
	 notlas = k .ne. na
	 if (k .eq. m) go to 170
	 p = h(k,k-1)
	 q = h(k+1,k-1)
	 r = 0.0d0
	 if (notlas) r = h(k+2,k-1)
	 x = dabs(p) + dabs(q) + dabs(r)
	 if (x .eq. 0.0d0) go to 260
	 p = p / x
	 q = q / x
	 r = r / x
  170    s = dsign(dsqrt(p*p+q*q+r*r),p)
	 if (k .eq. m) go to 180
	 h(k,k-1) = -s * x
	 go to 190
  180    if (l .ne. m) h(k,k-1) = -h(k,k-1)
  190    p = p + s
	 x = p / s
	 y = q / s
	 zz = r / s
	 q = q / p
	 r = r / p
	 if (notlas) go to 225
c     .......... row modification ..........
	 do 200 j = k, n
	    p = h(k,j) + q * h(k+1,j)
	    h(k,j) = h(k,j) - p * x
	    h(k+1,j) = h(k+1,j) - p * y
  200    continue
c
	 j = min0(en,k+3)
c     .......... column modification ..........
	 do 210 i = 1, j
	    p = x * h(i,k) + y * h(i,k+1)
	    h(i,k) = h(i,k) - p
	    h(i,k+1) = h(i,k+1) - p * q
  210    continue
c     .......... accumulate transformations ..........
	 do 220 i = low, igh
	    p = x * z(i,k) + y * z(i,k+1)
	    z(i,k) = z(i,k) - p
	    z(i,k+1) = z(i,k+1) - p * q
  220    continue
	 go to 255
  225    continue
c     .......... row modification ..........
	 do 230 j = k, n
	    p = h(k,j) + q * h(k+1,j) + r * h(k+2,j)
	    h(k,j) = h(k,j) - p * x
	    h(k+1,j) = h(k+1,j) - p * y
	    h(k+2,j) = h(k+2,j) - p * zz
  230    continue
c
	 j = min0(en,k+3)
c     .......... column modification ..........
	 do 240 i = 1, j
	    p = x * h(i,k) + y * h(i,k+1) + zz * h(i,k+2)
	    h(i,k) = h(i,k) - p
	    h(i,k+1) = h(i,k+1) - p * q
	    h(i,k+2) = h(i,k+2) - p * r
  240    continue
c     .......... accumulate transformations ..........
	 do 250 i = low, igh
	    p = x * z(i,k) + y * z(i,k+1) + zz * z(i,k+2)
	    z(i,k) = z(i,k) - p
	    z(i,k+1) = z(i,k+1) - p * q
	    z(i,k+2) = z(i,k+2) - p * r
  250    continue
  255    continue
c
  260 continue
c
      go to 70
c     .......... one root found ..........
  270 h(en,en) = x + t
      wr(en) = h(en,en)
      wi(en) = 0.0d0
      en = na
      go to 60
c     .......... two roots found ..........
  280 p = (y - x) / 2.0d0
      q = p * p + w
      zz = dsqrt(dabs(q))
      h(en,en) = x + t
      x = h(en,en)
      h(na,na) = y + t
      if (q .lt. 0.0d0) go to 320
c     .......... real pair ..........
      zz = p + dsign(zz,p)
      wr(na) = x + zz
      wr(en) = wr(na)
      if (zz .ne. 0.0d0) wr(en) = x - w / zz
      wi(na) = 0.0d0
      wi(en) = 0.0d0
      x = h(en,na)
      s = dabs(x) + dabs(zz)
      p = x / s
      q = zz / s
      r = dsqrt(p*p+q*q)
      p = p / r
      q = q / r
c     .......... row modification ..........
      do 290 j = na, n
	 zz = h(na,j)
	 h(na,j) = q * zz + p * h(en,j)
	 h(en,j) = q * h(en,j) - p * zz
  290 continue
c     .......... column modification ..........
      do 300 i = 1, en
	 zz = h(i,na)
	 h(i,na) = q * zz + p * h(i,en)
	 h(i,en) = q * h(i,en) - p * zz
  300 continue
c     .......... accumulate transformations ..........
      do 310 i = low, igh
	 zz = z(i,na)
	 z(i,na) = q * zz + p * z(i,en)
	 z(i,en) = q * z(i,en) - p * zz
  310 continue
c
      go to 330
c     .......... complex pair ..........
  320 wr(na) = x + p
      wr(en) = x + p
      wi(na) = zz
      wi(en) = -zz
  330 en = enm2
      go to 60
c     .......... all roots found.  backsubstitute to find
c                vectors of upper triangular form ..........
  340 if (norm .eq. 0.0d0) go to 1001
c     .......... for en=n step -1 until 1 do -- ..........
      do 800 nn = 1, n
	 en = n + 1 - nn
	 p = wr(en)
	 q = wi(en)
	 na = en - 1
	 if (q) 710, 600, 800
c     .......... real vector ..........
  600    m = en
	 h(en,en) = 1.0d0
	 if (na .eq. 0) go to 800
c     .......... for i=en-1 step -1 until 1 do -- ..........
	 do 700 ii = 1, na
	    i = en - ii
	    w = h(i,i) - p
	    r = 0.0d0
c
	    do 610 j = m, en
  610       r = r + h(i,j) * h(j,en)
c
	    if (wi(i) .ge. 0.0d0) go to 630
	    zz = w
	    s = r
	    go to 700
  630       m = i
	    if (wi(i) .ne. 0.0d0) go to 640
	    t = w
	    if (t .ne. 0.0d0) go to 635
	       tst1 = norm
	       t = tst1
  632          t = 0.01d0 * t
	       tst2 = norm + t
	       if (tst2 .gt. tst1) go to 632
  635       h(i,en) = -r / t
	    go to 680
c     .......... solve real equations ..........
  640       x = h(i,i+1)
	    y = h(i+1,i)
	    q = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i)
	    t = (x * s - zz * r) / q
	    h(i,en) = t
	    if (dabs(x) .le. dabs(zz)) go to 650
	    h(i+1,en) = (-r - w * t) / x
	    go to 680
  650       h(i+1,en) = (-s - y * t) / zz
c
c     .......... overflow control ..........
  680       t = dabs(h(i,en))
	    if (t .eq. 0.0d0) go to 700
	    tst1 = t
	    tst2 = tst1 + 1.0d0/tst1
	    if (tst2 .gt. tst1) go to 700
	    do 690 j = i, en
	       h(j,en) = h(j,en)/t
  690       continue
c
  700    continue
c     .......... end real vector ..........
	 go to 800
c     .......... complex vector ..........
  710    m = na
c     .......... last vector component chosen imaginary so that
c                eigenvector matrix is triangular ..........
	 if (dabs(h(en,na)) .le. dabs(h(na,en))) go to 720
	 h(na,na) = q / h(en,na)
	 h(na,en) = -(h(en,en) - p) / h(en,na)
	 go to 730
  720    call cdiv(0.0d0,-h(na,en),h(na,na)-p,q,h(na,na),h(na,en))
  730    h(en,na) = 0.0d0
	 h(en,en) = 1.0d0
	 enm2 = na - 1
	 if (enm2 .eq. 0) go to 800
c     .......... for i=en-2 step -1 until 1 do -- ..........
	 do 795 ii = 1, enm2
	    i = na - ii
	    w = h(i,i) - p
	    ra = 0.0d0
	    sa = 0.0d0
c
	    do 760 j = m, en
	       ra = ra + h(i,j) * h(j,na)
	       sa = sa + h(i,j) * h(j,en)
  760       continue
c
	    if (wi(i) .ge. 0.0d0) go to 770
	    zz = w
	    r = ra
	    s = sa
	    go to 795
  770       m = i
	    if (wi(i) .ne. 0.0d0) go to 780
	    call cdiv(-ra,-sa,w,q,h(i,na),h(i,en))
	    go to 790
c     .......... solve complex equations ..........
  780       x = h(i,i+1)
	    y = h(i+1,i)
	    vr = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i) - q * q
	    vi = (wr(i) - p) * 2.0d0 * q
	    if (vr .ne. 0.0d0 .or. vi .ne. 0.0d0) go to 784
	       tst1 = norm * (dabs(w) + dabs(q) + dabs(x)
     x                      + dabs(y) + dabs(zz))
	       vr = tst1
  783          vr = 0.01d0 * vr
	       tst2 = tst1 + vr
	       if (tst2 .gt. tst1) go to 783
  784       call cdiv(x*r-zz*ra+q*sa,x*s-zz*sa-q*ra,vr,vi,
     x                h(i,na),h(i,en))
	    if (dabs(x) .le. dabs(zz) + dabs(q)) go to 785
	    h(i+1,na) = (-ra - w * h(i,na) + q * h(i,en)) / x
	    h(i+1,en) = (-sa - w * h(i,en) - q * h(i,na)) / x
	    go to 790
  785       call cdiv(-r-y*h(i,na),-s-y*h(i,en),zz,q,
     x                h(i+1,na),h(i+1,en))
c
c     .......... overflow control ..........
  790       t = dmax1(dabs(h(i,na)), dabs(h(i,en)))
	    if (t .eq. 0.0d0) go to 795
	    tst1 = t
	    tst2 = tst1 + 1.0d0/tst1
	    if (tst2 .gt. tst1) go to 795
	    do 792 j = i, en
	       h(j,na) = h(j,na)/t
	       h(j,en) = h(j,en)/t
  792       continue
c
  795    continue
c     .......... end complex vector ..........
  800 continue
c     .......... end back substitution.
c                vectors of isolated roots ..........
      do 840 i = 1, n
	 if (i .ge. low .and. i .le. igh) go to 840
c
	 do 820 j = i, n
  820    z(i,j) = h(i,j)
c
  840 continue
c     .......... multiply by transformation matrix to give
c                vectors of original full matrix.
c                for j=n step -1 until low do -- ..........
      do 880 jj = low, n
	 j = n + low - jj
	 m = min0(j,igh)
c
	 do 880 i = low, igh
	    zz = 0.0d0
c
	    do 860 k = low, m
  860       zz = zz + z(i,k) * h(k,j)
c
	    z(i,j) = zz
  880 continue
c
      go to 1001
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end

      subroutine balbak(nm,n,low,igh,scale,m,z)
c
      integer i,j,k,m,n,ii,nm,igh,low
      double precision scale(n),z(nm,m)
      double precision s
c
c     this subroutine is a translation of the algol procedure balbak,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine forms the eigenvectors of a real general
c     matrix by back transforming those of the corresponding
c     balanced matrix determined by  balanc.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by  balanc.
c
c        scale contains information determining the permutations
c          and scaling factors used by  balanc.
c
c        m is the number of columns of z to be back transformed.
c
c        z contains the real and imaginary parts of the eigen-
c          vectors to be back transformed in its first m columns.
c
c     on output
c
c        z contains the real and imaginary parts of the
c          transformed eigenvectors in its first m columns.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (m .eq. 0) go to 200
      if (igh .eq. low) go to 120
c
      do 110 i = low, igh
	 s = scale(i)
c     .......... left hand eigenvectors are back transformed
c                if the foregoing statement is replaced by
c                s=1.0d0/scale(i). ..........
	 do 100 j = 1, m
  100    z(i,j) = z(i,j) * s
c
  110 continue
c     ......... for i=low-1 step -1 until 1,
c               igh+1 step 1 until n do -- ..........
  120 do 140 ii = 1, n
	 i = ii
	 if (i .ge. low .and. i .le. igh) go to 140
	 if (i .lt. low) i = low - ii
	 k = scale(i)
	 if (k .eq. i) go to 140
c
	 do 130 j = 1, m
	    s = z(i,j)
	    z(i,j) = z(k,j)
	    z(k,j) = s
  130    continue
c
  140 continue
c
  200 return
      end

      subroutine like(x1,xlag,beta,y1,nmax,icnt,alike)
C************************************************************************
C     PORPOSE: LIKELIHOOD ESTIMATION
C     INPUT: x1,xlag,beta,y1,nmax,ipmax,icnt,icol
C     OUTPUT: alike
C             IFAIL, MONITORING VALUE
C************************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION x1(nmax,*),xlag(nmax,*),y1(nmax,*),beta(*),x2(500,1)
      dimension x35(4,500),z0(500,4),x36(4,4)
      dimension zz0(4,4),zzz0(500,4),x37(4,500)
      dimension x38(4,2),x39(500,2),x40(500,2),x41(2,500)
      dimension x42(2,2),elp4(4,4),wk(2,2)
      EXTERNAL zeromat,multmat,trnmat,matinv,detmtx
c
      call zeromat(x2,500,icnt,1)
      call zeromat(x35,4,4,500)
      call zeromat(z0,500,500,4)
      call zeromat(x36,4,4,4)
      call zeromat(zz0,4,4,4)
      call zeromat(zzz0,500,500,4)
      call zeromat(x37,4,4,500)
      call zeromat(x38,4,4,2)
      call zeromat(x39,500,500,2)
      call zeromat(x40,500,500,2)
      call zeromat(x41,2,2,500)
      call zeromat(x42,2,2,2)
      call multmat(xlag,beta,x2,nmax,2,icnt,2,1)
      do 2 i=1,icnt
	 z0(i,1)=x2(i,1)
	 do 2 j=1,3
 2          z0(i,1+j)=x1(i,j)
      kk=4
      call trnmat(z0,x35,500,kk,icnt,kk)
      call multmat(x35,z0,x36,kk,500,kk,icnt,kk)
      call matinv(x36,zz0,elp4,kk,kk,ifail)
      call multmat(z0,zz0,zzz0,500,kk,icnt,kk,kk)
      call trnmat(zzz0,x37,500,kk,icnt,kk)
      call multmat(x37,y1,x38,kk,500,kk,icnt,2)
      call multmat(z0,x38,x39,500,kk,icnt,kk,2)
      call addmat(y1,x39,x40,500,icnt,2,-1)
      call trnmat(x40,x41,500,2,icnt,2)
      call multmat(x41,x40,x42,2,500,2,icnt,2)
      do 4 i=1,2
	 do 4 j=1,2
 4          x42(i,j)=x42(i,j)/real(icnt)
      call detmtx(x42,wk,2,2,det)
      alike=(dble(icnt)/2.0)*dlog(det)
      return
      end

      subroutine cdiv(ar,ai,br,bi,cr,ci)
      double precision ar,ai,br,bi,cr,ci
c
c     complex division, (cr,ci) = (ar,ai)/(br,bi)
c
      double precision s,ars,ais,brs,bis
      s = dabs(br) + dabs(bi)
      ars = ar/s
      ais = ai/s
      brs = br/s
      bis = bi/s
      s = brs**2 + bis**2
      cr = (ars*brs + ais*bis)/s
      ci = (ais*brs - ars*bis)/s
      return
      end

c*****************************************
       subroutine detmtx(a,wk,mx,k,det)
c
c---- This program computes the determinant of a covariance matrix.
c     It assumes that the variance of each variable is not close to zero.
c     The program transforms the mtx into an upper triangular one.
c
       real*8 a(mx,mx), det, tem, wk(mx,mx), crit
       integer mx, k, i, j, km1
c--------- wk(.,.) is a working area.
c
       if(k.eq.1)then
	det = a(1,1)
	return
       endif
c
       km1 = k-1
       crit = 1.0d-15
c
       do 10 i=1, k
	do 10 j=1, k
 10        wk(i,j) = a(i,j)
c
       do 50 i=1, km1
	if(dabs(a(i,i)).le.crit)then 
	 det = 0.0d0
	 return
	endif
	tem = wk(i+1,i)/a(i,i)
	do 40 j=i+1, k
 40       wk(i+1,j) = wk(i+1,j)-wk(i,j)*tem
 50      continue
c
       det = 1.0d0
       do 60 i=1, k
 60       det = det*wk(i,i)
c
cc       print*,'det = ', det
c
       return
       end
